#!/usr/bin/python

# Simple PartyMode Web Console
# Limited interface for normal party goers
# Copyright (c) 2015,2016  Clinton Ebadi <clinton@unknownlamer.org>
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# limit playlist view to next five

import sys
reload(sys)
sys.setdefaultencoding ('utf-8')

import cgi, cgitb
from datetime import datetime
import hashlib
import numbers
import os
import random
import subprocess
from xbmcjson import XBMC
from yattag import Doc

import partyparty
from partyparty import Song, SongControls, Search, Playlist, PartyManager

cgitb.enable()

print ("content-type: text/html; charset=utf-8\n\n")
sys.stdout.flush ()
print ("<!DOCTYPE html>\n<html><head><title>partyparty beb</title></head><body>")
print (partyparty.css ())

print '<p style="font-size: 5rem"><a href="upload.html">Upload A Song</a> | <a href="youtube.html">Add From YouTube</a> | <a href="normals.cgi">home</a> | <a href="normals.cgi?browseartists=1">browse</a></p>'



class NormalsPlaylist (Playlist):
    def get_playlist (self):
        return Playlist.get_playlist (self)[0:6]

class NormalsManager (PartyManager):
    DEFAULT_QUEUE_DIVISOR = 1    

xbmc = partyparty.connect (XBMC ("http://localhost:8080/jsonrpc"))

manager = NormalsManager (cgi.FieldStorage ())
manager.process ()
playlist = NormalsPlaylist ()

print ('<a name="search"></a>')
Search ().show_quick_search (thereal=True)

print ('<a name="playlist"></a><h1>What\'s Playing</h1>')
print (playlist.show (controls = []))

print ('</body></html>')
